Index: drivers/filesystems/btrfs/fsctl.c
===================================================================
--- drivers/filesystems/btrfs/fsctl.c	(révision 75772)
+++ drivers/filesystems/btrfs/fsctl.c	(copie de travail)
@@ -1443,25 +1535,25 @@
                 factor = c->chunk_item->num_stripes - 2;
             else
                 factor = 1;
-            
+
             le2 = le;
             while (le2 != &Vcb->chunks) {
                 chunk* c2 = CONTAINING_RECORD(le2, chunk, list_entry);
-                
+
                 if (c2->chunk_item->type == c->chunk_item->type) {
                     UINT16 i;
                     CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c2->chunk_item[1];
                     UINT64 stripesize;
-                    
+
                     bue->size += c2->chunk_item->size;
                     bue->used += c2->used;
-                    
+
                     stripesize = c2->chunk_item->size / factor;
-                    
+
                     for (i = 0; i < c2->chunk_item->num_stripes; i++) {
                         UINT64 j;
                         BOOL found = FALSE;
-                        
+
                         for (j = 0; j < bue->num_devices; j++) {
                             if (bue->devices[j].dev_id == cis[i].dev_id) {
                                 bue->devices[j].alloc += stripesize;
@@ -1469,15 +1561,15 @@
                                 break;
                             }
                         }
-                        
+
                         if (!found) {
                             if (length < sizeof(btrfs_usage_device)) {
                                 Status = STATUS_BUFFER_OVERFLOW;
                                 goto end;
                             }
-                            
+
                             length -= sizeof(btrfs_usage_device);
-                            
+
                             bue->devices[bue->num_devices].dev_id = cis[i].dev_id;
                             bue->devices[bue->num_devices].alloc = stripesize;
                             bue->num_devices++;
@@ -1484,21 +1576,21 @@
                         }
                     }
                 }
-                
+
                 le2 = le2->Flink;
             }
-            
+
             lastbue = bue;
         }
 
         le = le->Flink;
     }
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     ExReleaseResourceLite(&Vcb->chunk_lock);
-      
+
     return Status;
 }
 
@@ -1508,62 +1600,62 @@
     IO_STATUS_BLOCK iosb;
     BOOL verify = FALSE;
     LIST_ENTRY* le;
-    
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
         device* dev = CONTAINING_RECORD(le, device, list_entry);
-        
+
         if (dev->devobj && dev->removable) {
             Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), FALSE, &iosb);
-            
+
             if (iosb.Information != sizeof(ULONG))
                 cc = 0;
-            
+
             if (Status == STATUS_VERIFY_REQUIRED || (NT_SUCCESS(Status) && cc != dev->change_count)) {
                 dev->devobj->Flags |= DO_VERIFY_VOLUME;
                 verify = TRUE;
             }
-            
+
             if (NT_SUCCESS(Status) && iosb.Information == sizeof(ULONG))
                 dev->change_count = cc;
-            
+
             if (!NT_SUCCESS(Status) || verify) {
                 IoSetHardErrorOrVerifyDevice(Irp, dev->devobj);
                 ExReleaseResourceLite(&Vcb->tree_lock);
-                
+
                 return verify ? STATUS_VERIFY_REQUIRED : Status;
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS fs_get_statistics(PDEVICE_OBJECT DeviceObject, PFILE_OBJECT FileObject, void* buffer, DWORD buflen, ULONG_PTR* retlen) {
+static NTSTATUS fs_get_statistics(void* buffer, DWORD buflen, ULONG_PTR* retlen) {
     FILESYSTEM_STATISTICS* fss;
-    
+
     WARN("STUB: FSCTL_FILESYSTEM_GET_STATISTICS\n");
-    
+
     // This is hideously wrong, but at least it stops SMB from breaking
-    
+
     if (buflen < sizeof(FILESYSTEM_STATISTICS))
         return STATUS_BUFFER_TOO_SMALL;
-    
+
     fss = buffer;
     RtlZeroMemory(fss, sizeof(FILESYSTEM_STATISTICS));
-    
+
     fss->Version = 1;
     fss->FileSystemType = FILESYSTEM_STATISTICS_TYPE_NTFS;
     fss->SizeOfCompleteStructure = sizeof(FILESYSTEM_STATISTICS);
-    
+
     *retlen = sizeof(FILESYSTEM_STATISTICS);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -1574,104 +1666,121 @@
     fcb* fcb;
     ccb* ccb = FileObject->FsContext2;
     file_ref* fileref = ccb ? ccb->fileref : NULL;
-    
+
     if (data && length < sizeof(FILE_SET_SPARSE_BUFFER))
         return STATUS_INVALID_PARAMETER;
-    
+
     if (!FileObject) {
         ERR("FileObject was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb) {
         ERR("FCB was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (!ccb) {
         ERR("CCB was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (Irp->RequestorMode == UserMode && !(ccb->access & FILE_WRITE_ATTRIBUTES)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
+
     if (!fileref) {
         ERR("no fileref\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
+    if (fcb->ads) {
+        fileref = fileref->parent;
+        fcb = fileref->fcb;
+    }
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     if (fcb->type != BTRFS_TYPE_FILE) {
         WARN("FileObject did not point to a file\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (fssb)
         set = fssb->SetSparse;
     else
         set = TRUE;
-    
+
     if (set) {
         fcb->atts |= FILE_ATTRIBUTE_SPARSE_FILE;
         fcb->atts_changed = TRUE;
     } else {
         ULONG defda;
-        
+
         fcb->atts &= ~FILE_ATTRIBUTE_SPARSE_FILE;
         fcb->atts_changed = TRUE;
-        
-        defda = get_file_attributes(Vcb, &fcb->inode_item, fcb->subvol, fcb->inode, fcb->type,
-                                    fileref && fileref->filepart.Length > 0 && fileref->filepart.Buffer[0] == '.', TRUE, Irp);
-        
+
+        defda = get_file_attributes(Vcb, fcb->subvol, fcb->inode, fcb->type,
+                                    fileref && fileref->dc && fileref->dc->name.Length >= sizeof(WCHAR) && fileref->dc->name.Buffer[0] == '.', TRUE, Irp);
+
         fcb->atts_deleted = defda == fcb->atts;
     }
-    
+
     mark_fcb_dirty(fcb);
-    send_notification_fcb(fileref, FILE_NOTIFY_CHANGE_ATTRIBUTES, FILE_ACTION_MODIFIED);
-    
+    send_notification_fcb(fileref, FILE_NOTIFY_CHANGE_ATTRIBUTES, FILE_ACTION_MODIFIED, NULL);
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     ExReleaseResourceLite(fcb->Header.Resource);
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return Status;
 }
 
 static NTSTATUS zero_data(device_extension* Vcb, fcb* fcb, UINT64 start, UINT64 length, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
-    BOOL compress = write_fcb_compressed(fcb);
+    BOOL make_inline, compress;
     UINT64 start_data, end_data;
+    ULONG buf_head;
     UINT8* data;
-        
-    if (compress) {
+
+    make_inline = fcb->inode_item.st_size <= Vcb->options.max_inline || fcb_is_inline(fcb);
+
+    if (!make_inline)
+        compress = write_fcb_compressed(fcb);
+
+    if (make_inline) {
+        start_data = 0;
+        end_data = fcb->inode_item.st_size;
+        buf_head = (ULONG)offsetof(EXTENT_DATA, data[0]);
+    } else if (compress) {
         start_data = start & ~(UINT64)(COMPRESSED_EXTENT_SIZE - 1);
         end_data = min(sector_align(start + length, COMPRESSED_EXTENT_SIZE),
-                       sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size));
+                       sector_align(fcb->inode_item.st_size, Vcb->superblock.sector_size));
+        buf_head = 0;
     } else {
-        start_data = start & ~(UINT64)(fcb->Vcb->superblock.sector_size - 1);
-        end_data = sector_align(start + length, fcb->Vcb->superblock.sector_size);
+        start_data = start & ~(UINT64)(Vcb->superblock.sector_size - 1);
+        end_data = sector_align(start + length, Vcb->superblock.sector_size);
+        buf_head = 0;
     }
 
-    data = ExAllocatePoolWithTag(PagedPool, end_data - start_data, ALLOC_TAG);
+    data = ExAllocatePoolWithTag(PagedPool, (ULONG)(buf_head + end_data - start_data), ALLOC_TAG);
     if (!data) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    RtlZeroMemory(data, end_data - start_data);
-    
+
+    RtlZeroMemory(data + buf_head, (ULONG)(end_data - start_data));
+
     if (start > start_data || start + length < end_data) {
-        Status = read_file(fcb, data, start_data, end_data - start_data, NULL, Irp, TRUE);
-        
+        Status = read_file(fcb, data + buf_head, start_data, end_data - start_data, NULL, Irp);
+
         if (!NT_SUCCESS(Status)) {
             ERR("read_file returned %08x\n", Status);
             ExFreePool(data);
@@ -1678,29 +1787,59 @@
             return Status;
         }
     }
-    
-    RtlZeroMemory(data + start - start_data, length);
-    
-    if (compress) {
+
+    RtlZeroMemory(data + buf_head + start - start_data, (ULONG)length);
+
+    if (make_inline) {
+        UINT16 edsize;
+        EXTENT_DATA* ed = (EXTENT_DATA*)data;
+
+        Status = excise_extents(Vcb, fcb, 0, sector_align(end_data, Vcb->superblock.sector_size), Irp, rollback);
+        if (!NT_SUCCESS(Status)) {
+            ERR("excise_extents returned %08x\n", Status);
+            ExFreePool(data);
+            return Status;
+        }
+
+        edsize = (UINT16)(offsetof(EXTENT_DATA, data[0]) + end_data);
+
+        ed->generation = Vcb->superblock.generation;
+        ed->decoded_size = end_data;
+        ed->compression = BTRFS_COMPRESSION_NONE;
+        ed->encryption = BTRFS_ENCRYPTION_NONE;
+        ed->encoding = BTRFS_ENCODING_NONE;
+        ed->type = EXTENT_TYPE_INLINE;
+
+        Status = add_extent_to_fcb(fcb, 0, ed, edsize, FALSE, NULL, rollback);
+        if (!NT_SUCCESS(Status)) {
+            ERR("add_extent_to_fcb returned %08x\n", Status);
+            ExFreePool(data);
+            return Status;
+        }
+
+        ExFreePool(data);
+
+        fcb->inode_item.st_blocks += end_data;
+    } else if (compress) {
         Status = write_compressed(fcb, start_data, end_data, data, Irp, rollback);
-        
+
         ExFreePool(data);
-        
+
         if (!NT_SUCCESS(Status)) {
             ERR("write_compressed returned %08x\n", Status);
             return Status;
         }
     } else {
-        Status = do_write_file(fcb, start_data, end_data, data, Irp, rollback);
-        
+        Status = do_write_file(fcb, start_data, end_data, data, Irp, FALSE, 0, rollback);
+
         ExFreePool(data);
-        
+
         if (!NT_SUCCESS(Status)) {
             ERR("do_write_file returned %08x\n", Status);
             return Status;
         }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -1716,75 +1855,75 @@
     UINT64 start, end;
     extent* ext;
     IO_STATUS_BLOCK iosb;
-    
+
     if (!data || length < sizeof(FILE_ZERO_DATA_INFORMATION))
         return STATUS_INVALID_PARAMETER;
-    
+
     if (!FileObject) {
         ERR("FileObject was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (fzdi->BeyondFinalZero.QuadPart <= fzdi->FileOffset.QuadPart) {
         WARN("BeyondFinalZero was less than or equal to FileOffset (%llx <= %llx)\n", fzdi->BeyondFinalZero.QuadPart, fzdi->FileOffset.QuadPart);
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb) {
         ERR("FCB was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     ccb = FileObject->FsContext2;
-    
+
     if (!ccb) {
         ERR("ccb was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (Irp->RequestorMode == UserMode && !(ccb->access & FILE_WRITE_DATA)) {
         WARN("insufficient privileges\n");
         return STATUS_ACCESS_DENIED;
     }
-    
+
     fileref = ccb->fileref;
-    
+
     if (!fileref) {
         ERR("fileref was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     InitializeListHead(&rollback);
-    
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     CcFlushCache(&fcb->nonpaged->segment_object, NULL, 0, &iosb);
-    
+
     if (fcb->type != BTRFS_TYPE_FILE) {
         WARN("FileObject did not point to a file\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     if (fcb->ads) {
         ERR("FileObject is stream\n");
         Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
-    if (fzdi->FileOffset.QuadPart >= fcb->inode_item.st_size) {
+
+    if ((UINT64)fzdi->FileOffset.QuadPart >= fcb->inode_item.st_size) {
         Status = STATUS_SUCCESS;
         goto end;
     }
-    
+
     ext = NULL;
     le = fcb->extents.Flink;
     while (le != &fcb->extents) {
         extent* ext2 = CONTAINING_RECORD(le, extent, list_entry);
-        
+
         if (!ext2->ignore) {
             ext = ext2;
             break;
@@ -1792,13 +1931,13 @@
 
         le = le->Flink;
     }
-    
+
     if (!ext) {
         Status = STATUS_SUCCESS;
         goto end;
     }
-    
-    if (ext->datalen >= sizeof(EXTENT_DATA) && ext->data->type == EXTENT_TYPE_INLINE) {
+
+    if (ext->extent_data.type == EXTENT_TYPE_INLINE) {
         Status = zero_data(Vcb, fcb, fzdi->FileOffset.QuadPart, fzdi->BeyondFinalZero.QuadPart - fzdi->FileOffset.QuadPart, Irp, &rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("zero_data returned %08x\n", Status);
@@ -1806,12 +1945,12 @@
         }
     } else {
         start = sector_align(fzdi->FileOffset.QuadPart, Vcb->superblock.sector_size);
-        
-        if (fzdi->BeyondFinalZero.QuadPart > fcb->inode_item.st_size)
+
+        if ((UINT64)fzdi->BeyondFinalZero.QuadPart > fcb->inode_item.st_size)
             end = sector_align(fcb->inode_item.st_size, Vcb->superblock.sector_size);
         else
             end = (fzdi->BeyondFinalZero.QuadPart / Vcb->superblock.sector_size) * Vcb->superblock.sector_size;
-        
+
         if (end <= start) {
             Status = zero_data(Vcb, fcb, fzdi->FileOffset.QuadPart, fzdi->BeyondFinalZero.QuadPart - fzdi->FileOffset.QuadPart, Irp, &rollback);
             if (!NT_SUCCESS(Status)) {
@@ -1819,7 +1958,7 @@
                 goto end;
             }
         } else {
-            if (start > fzdi->FileOffset.QuadPart) {
+            if (start > (UINT64)fzdi->FileOffset.QuadPart) {
                 Status = zero_data(Vcb, fcb, fzdi->FileOffset.QuadPart, start - fzdi->FileOffset.QuadPart, Irp, &rollback);
                 if (!NT_SUCCESS(Status)) {
                     ERR("zero_data returned %08x\n", Status);
@@ -1826,8 +1965,8 @@
                     goto end;
                 }
             }
-            
-            if (end < fzdi->BeyondFinalZero.QuadPart) {
+
+            if (end < (UINT64)fzdi->BeyondFinalZero.QuadPart) {
                 Status = zero_data(Vcb, fcb, end, fzdi->BeyondFinalZero.QuadPart - end, Irp, &rollback);
                 if (!NT_SUCCESS(Status)) {
                     ERR("zero_data returned %08x\n", Status);
@@ -1834,7 +1973,7 @@
                     goto end;
                 }
             }
-            
+
             if (end > start) {
                 Status = excise_extents(Vcb, fcb, start, end, Irp, &rollback);
                 if (!NT_SUCCESS(Status)) {
@@ -1844,45 +1983,45 @@
             }
         }
     }
-    
-    CcPurgeCacheSection(&fcb->nonpaged->segment_object, &fzdi->FileOffset, fzdi->BeyondFinalZero.QuadPart - fzdi->FileOffset.QuadPart, FALSE);
-    
+
+    CcPurgeCacheSection(&fcb->nonpaged->segment_object, &fzdi->FileOffset, (ULONG)(fzdi->BeyondFinalZero.QuadPart - fzdi->FileOffset.QuadPart), FALSE);
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
+
     fcb->inode_item.transid = Vcb->superblock.generation;
     fcb->inode_item.sequence++;
-    
+
     if (!ccb->user_set_change_time)
         fcb->inode_item.st_ctime = now;
-    
+
     if (!ccb->user_set_write_time)
         fcb->inode_item.st_mtime = now;
-    
+
     fcb->extents_changed = TRUE;
     fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fcb);
-    
-    send_notification_fcb(fileref, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
-    
+
+    send_notification_fcb(fileref, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+
     fcb->subvol->root_item.ctransid = Vcb->superblock.generation;
     fcb->subvol->root_item.ctime = now;
 
     Status = STATUS_SUCCESS;
-    
+
 end:
     if (!NT_SUCCESS(Status))
         do_rollback(Vcb, &rollback);
     else
-        clear_rollback(Vcb, &rollback);
-    
+        clear_rollback(&rollback);
+
     ExReleaseResourceLite(fcb->Header.Resource);
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return Status;
 }
 
-static NTSTATUS query_ranges(device_extension* Vcb, PFILE_OBJECT FileObject, FILE_ALLOCATED_RANGE_BUFFER* inbuf, ULONG inbuflen, void* outbuf, ULONG outbuflen, ULONG_PTR* retlen) {
+static NTSTATUS query_ranges(PFILE_OBJECT FileObject, FILE_ALLOCATED_RANGE_BUFFER* inbuf, ULONG inbuflen, void* outbuf, ULONG outbuflen, ULONG_PTR* retlen) {
     NTSTATUS Status;
     fcb* fcb;
     LIST_ENTRY* le;
@@ -1889,28 +2028,28 @@
     FILE_ALLOCATED_RANGE_BUFFER* ranges = outbuf;
     ULONG i = 0;
     UINT64 last_start, last_end;
-    
+
     TRACE("FSCTL_QUERY_ALLOCATED_RANGES\n");
-    
+
     if (!FileObject) {
         ERR("FileObject was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (!inbuf || inbuflen < sizeof(FILE_ALLOCATED_RANGE_BUFFER) || !outbuf)
         return STATUS_INVALID_PARAMETER;
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb) {
         ERR("FCB was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     ExAcquireResourceSharedLite(fcb->Header.Resource, TRUE);
-    
+
     // If file is not marked as sparse, claim the whole thing as an allocated range
-    
+
     if (!(fcb->atts & FILE_ATTRIBUTE_SPARSE_FILE)) {
         if (fcb->inode_item.st_size == 0)
             Status = STATUS_SUCCESS;
@@ -1922,23 +2061,23 @@
             i++;
             Status = STATUS_SUCCESS;
         }
-        
+
         goto end;
-            
+
     }
-    
+
     le = fcb->extents.Flink;
-    
+
     last_start = 0;
     last_end = 0;
-    
+
     while (le != &fcb->extents) {
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-        
+
         if (!ext->ignore) {
-            EXTENT_DATA2* ed2 = (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) ? (EXTENT_DATA2*)ext->data->data : NULL;
-            UINT64 len = ed2 ? ed2->num_bytes : ext->data->decoded_size;
-            
+            EXTENT_DATA2* ed2 = (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) ? (EXTENT_DATA2*)ext->extent_data.data : NULL;
+            UINT64 len = ed2 ? ed2->num_bytes : ext->extent_data.decoded_size;
+
             if (ext->offset > last_end) { // first extent after a hole
                 if (last_end > last_start) {
                     if ((i + 1) * sizeof(FILE_ALLOCATED_RANGE_BUFFER) <= outbuflen) {
@@ -1950,16 +2089,16 @@
                         goto end;
                     }
                 }
-                
+
                 last_start = ext->offset;
             }
-            
+
             last_end = ext->offset + len;
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (last_end > last_start) {
         if ((i + 1) * sizeof(FILE_ALLOCATED_RANGE_BUFFER) <= outbuflen) {
             ranges[i].FileOffset.QuadPart = last_start;
@@ -1972,60 +2111,60 @@
     }
 
     Status = STATUS_SUCCESS;
-    
+
 end:
     *retlen = i * sizeof(FILE_ALLOCATED_RANGE_BUFFER);
-    
+
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     return Status;
 }
 
 static NTSTATUS get_object_id(device_extension* Vcb, PFILE_OBJECT FileObject, FILE_OBJECTID_BUFFER* buf, ULONG buflen, ULONG_PTR* retlen) {
     fcb* fcb;
-    
+
     TRACE("(%p, %p, %p, %x, %p)\n", Vcb, FileObject, buf, buflen, retlen);
-    
+
     if (!FileObject) {
         ERR("FileObject was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     if (!buf || buflen < sizeof(FILE_OBJECTID_BUFFER))
         return STATUS_INVALID_PARAMETER;
-    
+
     fcb = FileObject->FsContext;
-    
+
     if (!fcb) {
         ERR("FCB was NULL\n");
         return STATUS_INVALID_PARAMETER;
     }
-    
+
     ExAcquireResourceSharedLite(fcb->Header.Resource, TRUE);
-    
+
     RtlCopyMemory(&buf->ObjectId[0], &fcb->inode, sizeof(UINT64));
     RtlCopyMemory(&buf->ObjectId[sizeof(UINT64)], &fcb->subvol->id, sizeof(UINT64));
-    
+
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     RtlZeroMemory(&buf->ExtendedInfo, sizeof(buf->ExtendedInfo));
-    
+
     *retlen = sizeof(FILE_OBJECTID_BUFFER);
-    
+
     return STATUS_SUCCESS;
 }
 
 static void flush_fcb_caches(device_extension* Vcb) {
     LIST_ENTRY* le;
-    
+
     le = Vcb->all_fcbs.Flink;
     while (le != &Vcb->all_fcbs) {
         struct _fcb* fcb = CONTAINING_RECORD(le, struct _fcb, list_entry_all);
         IO_STATUS_BLOCK iosb;
-        
+
         if (fcb->type != BTRFS_TYPE_DIRECTORY && !fcb->deleted)
             CcFlushCache(&fcb->nonpaged->segment_object, NULL, 0, &iosb);
-        
+
         le = le->Flink;
     }
 }
@@ -2033,55 +2172,67 @@
 static NTSTATUS lock_volume(device_extension* Vcb, PIRP Irp) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     NTSTATUS Status;
-    LIST_ENTRY rollback;
     KIRQL irql;
     BOOL lock_paused_balance = FALSE;
-    
+
     TRACE("FSCTL_LOCK_VOLUME\n");
-    
+
+    if (Vcb->scrub.thread) {
+        WARN("cannot lock while scrub running\n");
+        return STATUS_DEVICE_NOT_READY;
+    }
+
+    if (Vcb->balance.thread) {
+        WARN("cannot lock while balance running\n");
+        return STATUS_DEVICE_NOT_READY;
+    }
+
     TRACE("locking volume\n");
-    
+
     FsRtlNotifyVolumeEvent(IrpSp->FileObject, FSRTL_VOLUME_LOCK);
-    
+
     if (Vcb->locked)
         return STATUS_SUCCESS;
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
-    
+
     if (Vcb->root_fileref && Vcb->root_fileref->fcb && (Vcb->root_fileref->open_count > 0 || has_open_children(Vcb->root_fileref))) {
         Status = STATUS_ACCESS_DENIED;
         ExReleaseResourceLite(&Vcb->fcb_lock);
         goto end;
     }
-    
+
     ExReleaseResourceLite(&Vcb->fcb_lock);
-    
-    InitializeListHead(&rollback);
-    
+
     if (Vcb->balance.thread && KeReadStateEvent(&Vcb->balance.event)) {
         ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
         KeClearEvent(&Vcb->balance.event);
         ExReleaseResourceLite(&Vcb->tree_lock);
-        
+
         lock_paused_balance = TRUE;
     }
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-    
+
     flush_fcb_caches(Vcb);
-    
+
     if (Vcb->need_write && !Vcb->readonly)
-        do_write(Vcb, Irp, &rollback);
-    
+        Status = do_write(Vcb, Irp);
+    else
+        Status = STATUS_SUCCESS;
+
     free_trees(Vcb);
-    
-    clear_rollback(Vcb, &rollback);
-    
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_write returned %08x\n", Status);
+        goto end;
+    }
+
     IoAcquireVpbSpinLock(&irql);
 
-    if (!(Vcb->Vpb->Flags & VPB_LOCKED)) { 
+    if (!(Vcb->Vpb->Flags & VPB_LOCKED)) {
         Vcb->Vpb->Flags |= VPB_LOCKED;
         Vcb->locked = TRUE;
         Vcb->locked_fileobj = IrpSp->FileObject;
@@ -2089,21 +2240,21 @@
     } else {
         Status = STATUS_ACCESS_DENIED;
         IoReleaseVpbSpinLock(irql);
-        
+
         if (lock_paused_balance)
             KeSetEvent(&Vcb->balance.event, 0, FALSE);
-        
+
         goto end;
     }
 
     IoReleaseVpbSpinLock(irql);
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     if (!NT_SUCCESS(Status))
         FsRtlNotifyVolumeEvent(IrpSp->FileObject, FSRTL_VOLUME_LOCK_FAILED);
-    
+
     return Status;
 }
 
@@ -2117,7 +2268,7 @@
     Vcb->locked_fileobj = NULL;
 
     IoReleaseVpbSpinLock(irql);
-    
+
     if (Vcb->lock_paused_balance)
         KeSetEvent(&Vcb->balance.event, 0, FALSE);
 }
@@ -2124,16 +2275,16 @@
 
 static NTSTATUS unlock_volume(device_extension* Vcb, PIRP Irp) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
-    
+
     TRACE("FSCTL_UNLOCK_VOLUME\n");
-    
+
     if (!Vcb->locked || IrpSp->FileObject != Vcb->locked_fileobj)
         return STATUS_NOT_LOCKED;
-    
+
     TRACE("unlocking volume\n");
-    
+
     do_unlock_volume(Vcb);
-    
+
     FsRtlNotifyVolumeEvent(IrpSp->FileObject, FSRTL_VOLUME_UNLOCK);
 
     return STATUS_SUCCESS;
@@ -2147,9 +2298,9 @@
     PFILE_OBJECT fileobj;
     PDEVICE_OBJECT devobj;
     LIST_ENTRY* le;
-    
+
     TRACE("FSCTL_INVALIDATE_VOLUMES\n");
-    
+
     if (!SeSinglePrivilegeCheck(TcbPrivilege, Irp->RequestorMode))
         return STATUS_PRIVILEGE_NOT_HELD;
 
@@ -2169,30 +2320,28 @@
     }
 #endif
 
-    Status = ObReferenceObjectByHandle(h, 0, *IoFileObjectType, KernelMode, (void**)&fileobj, NULL);
+    Status = ObReferenceObjectByHandle(h, 0, *IoFileObjectType, Irp->RequestorMode, (void**)&fileobj, NULL);
 
     if (!NT_SUCCESS(Status)) {
         ERR("ObReferenceObjectByHandle returned %08x\n", Status);
         return Status;
     }
-    
+
     devobj = fileobj->DeviceObject;
-    ObDereferenceObject(fileobj);
 
     ExAcquireResourceSharedLite(&global_loading_lock, TRUE);
-    
+
     le = VcbList.Flink;
-    
+
     while (le != &VcbList) {
         device_extension* Vcb = CONTAINING_RECORD(le, device_extension, list_entry);
-        
+
         if (Vcb->Vpb && Vcb->Vpb->RealDevice == devobj) {
             if (Vcb->Vpb == devobj->Vpb) {
                 KIRQL irql;
                 PVPB newvpb;
                 BOOL free_newvpb = FALSE;
-                LIST_ENTRY rollback;
-                
+
                 newvpb = ExAllocatePoolWithTag(NonPagedPool, sizeof(VPB), ALLOC_TAG);
                 if (!newvpb) {
                     ERR("out of memory\n");
@@ -2199,38 +2348,42 @@
                     Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto end;
                 }
-                
+
                 RtlZeroMemory(newvpb, sizeof(VPB));
-                
+
                 IoAcquireVpbSpinLock(&irql);
                 devobj->Vpb->Flags &= ~VPB_MOUNTED;
                 IoReleaseVpbSpinLock(irql);
-                
-                InitializeListHead(&rollback);
-                
+
                 ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-                
+
                 Vcb->removing = TRUE;
-                
+
                 ExReleaseResourceLite(&Vcb->tree_lock);
-                
+
                 CcWaitForCurrentLazyWriterActivity();
-                
+
                 ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-                
+
                 flush_fcb_caches(Vcb);
-                
+
                 if (Vcb->need_write && !Vcb->readonly)
-                    do_write(Vcb, Irp, &rollback);
-                
+                    Status = do_write(Vcb, Irp);
+                else
+                    Status = STATUS_SUCCESS;
+
                 free_trees(Vcb);
-                
-                clear_rollback(Vcb, &rollback);
-                
+
+                if (!NT_SUCCESS(Status)) {
+                    ERR("do_write returned %08x\n", Status);
+                    ExReleaseResourceLite(&Vcb->tree_lock);
+                    goto end;
+                }
+
                 flush_fcb_caches(Vcb);
-                
+
                 ExReleaseResourceLite(&Vcb->tree_lock);
-                    
+
                 IoAcquireVpbSpinLock(&irql);
 
                 if (devobj->Vpb->Flags & VPB_MOUNTED) {
@@ -2238,30 +2391,33 @@
                     newvpb->Size = sizeof(VPB);
                     newvpb->RealDevice = devobj;
                     newvpb->Flags = devobj->Vpb->Flags & VPB_REMOVE_PENDING;
-                    
+
                     devobj->Vpb = newvpb;
                 } else
                     free_newvpb = TRUE;
 
                 IoReleaseVpbSpinLock(irql);
-                
+
                 if (free_newvpb)
                     ExFreePool(newvpb);
-                
-                uninit(Vcb, FALSE);
+
+                if (Vcb->open_files == 0)
+                    uninit(Vcb, FALSE);
             }
-            
+
             break;
         }
-        
+
         le = le->Flink;
     }
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     ExReleaseResourceLite(&global_loading_lock);
-    
+
+    ObDereferenceObject(fileobj);
+
     return Status;
 }
 
@@ -2283,7 +2439,7 @@
         return STATUS_INVALID_PARAMETER;
 
     *volstate = 0;
-    
+
     if (IrpSp->FileObject->FsContext != Vcb->volume_fcb)
         return STATUS_INVALID_PARAMETER;
 
@@ -2292,10 +2448,10 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS get_compression(device_extension* Vcb, PIRP Irp) {
+static NTSTATUS get_compression(PIRP Irp) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     USHORT* compression;
-    
+
     TRACE("FSCTL_GET_COMPRESSION\n");
 
     if (Irp->AssociatedIrp.SystemBuffer) {
